package com.myoa.engineering.crawl.shopping.infra.client.fmkorea;

import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.client.WebClient;

@Slf4j
@Component
public class FmkoreaBoardClientV2 {

    private static final String URI_BOARD = "/index.php";

    private final WebClient webClient;

    public FmkoreaBoardClientV2() {
        webClient = WebClient.builder()
                             .codecs(configurer -> configurer.defaultCodecs()
                                                             .maxInMemorySize(2 * 1024 * 1024))
                             .baseUrl("https://www.fmkorea.com")
                             .build();
    }

    public String getBoardHtml(Integer page, String cookie) {
        return webClient.get()
                        .uri(builder -> builder.path(URI_BOARD)
                                               .queryParam("page", page)
                                               .queryParam("mid", "hotdeal")
                                               .build())
                        .header("Cookie", cookie)
                        .exchangeToMono(clientResponse -> clientResponse.bodyToMono(String.class))
                        .block();
    }
}
