package com.myoa.engineering.crawl.shopping.scheduler;

import com.myoa.engineering.crawl.shopping.crawlhandler.CrawlHandler;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Profile;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;

@Slf4j
@Component
@EnableScheduling
@Profile("!local")
public class ParseEventEmitter {
    private final List<CrawlHandler> crawlHandlers;


    public ParseEventEmitter(List<CrawlHandler> crawlHandlers) {
        this.crawlHandlers = crawlHandlers;
    }

    @Scheduled(cron = "0 0/15 * * * ?")
    public void emit() {
        log.info("[emit] trigger fired!");
        crawlHandlers.forEach(CrawlHandler::handle);

    }
}
